"""
Python code to test the  Algorithms 3.1 presented in
"Deterministic Sparse Sublinear FFT with Improved Numerical Stability"
by Gerlind Plonka and Therese von Wulffen
"""

from sparse_fft import sparse_ifft
import numpy as np

#set values for t_max
taumaxlist=[1,5]

# RANDOM SAMPLING VECTOR OF LENGTH N WITH SPARSITY M
#set sparsity and length of vector
M=50
N=2**17

I=[]
while len(I)!=M:
    r=np.random.randint(0,N)
    if r not in I:
        I.append(r)
I=sorted(I)
x=np.zeros(N,dtype='complex')
for i in I:
    x[i]= np.random.randint(1,500)+np.random.random()+(np.random.randint(1,500)+np.random.random())*1j

xshort=[x[i] for i in I]
xd=np.fft.fft(x)
print("Results for random sampling vector")
for t in taumaxlist:
    Inew,_,xnew =sparse_ifft(xd,threshold=0.01,taumax=t, accuracy=5)
    print("results for tau_max={}".format(t))
    if len(Inew)!=len(I):
        print("calculation failed for tau_{}\n".format(t))
    else:
        print("correct calculated Indices set? {} ".format(Inew==I))
        print("max deviation from original vector: {} \n".format(np.max(abs(np.array(xnew)-np.array(xshort)))))


#DETERMINISTIC SAMPLING VECTOR
N=2**20
x=np.zeros(N,dtype='complex')
#set active indices
I=sorted([23772,33892,251468,261768,849908, 51 ,54,55,180,181,182])

#set vector entries
x[23772]=1
x[33892]=1
x[251468]=1
x[261768]=1
x[849908]=1
x[51] = 5
x[54] = 8
x[55] = 1
x[180] = 2
x[181] = 7
x[182] = 4

xd=np.fft.fft(x)
xshort=[x[i] for i in I]
print("Results for deterministic sampling vector")
for t in taumaxlist:
    Inew,_,xnew =sparse_ifft(xd,threshold=0.01,taumax=t, accuracy=5)
    print("results for tau_max={}:".format(t))
    print("correct  calculated Indices set? {} ".format(Inew==I))
    print("max deviation from original vector: {} \n".format(np.max(abs(np.array(xnew)-np.array(xshort)))))